]> arthur.barton.de Git - backup-script.git/blob - bin/backup-script
Add compatibility layer for backup-pull(1) config files
[backup-script.git] / bin / backup-script
1 #!/bin/bash
2 #
3 # backup-script system for cloning systems using rsync
4 # Copyright (c)2008-2015 Alexander Barton <alex@barton.de>
5 #
6 # This program is free software; you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation; either version 2 of the License, or
9 # (at your option) any later version.
10 # Please read the file COPYING, README and AUTHORS for more information.
11 #
12
13 NAME=$(basename "$0")
14 PIDFILE="/var/run/$NAME.pid"
15
16 DRYRUN=0
17 VERBOSE=0
18
19 export LC_ALL=C
20
21 declare -i count_all=0
22 declare -i count_started=0
23 declare -i count_ok=0
24 declare -i count_ok_vanished=0
25
26 destinations=""
27
28 # Default settings, can be overwritten in backup-script.conf:
29 conf_d="/etc/backup-script.d"
30 pre_exec=""
31 post_exec=""
32 default_source_root="/"
33 default_target=""
34 default_user="root"
35 default_ssh_args_add=""
36 default_rsync_args_add=""
37 default_exclude_args_add=""
38 default_compress=1
39 default_ping=1
40 default_local=0
41 default_generations=0
42 default_job_pre_exec=""
43 default_job_post_exec=""
44
45 Usage() {
46         echo "Usage: $NAME [<options>] [<system> [<system> [...]]]"
47         echo
48         echo "  -p, --progress    Show progress, see rsync(1)."
49         echo "  -n, --dry-run     Test run only, don't copy any data."
50         echo
51         echo "When no <system> is given, all defined systems are used."
52         echo
53         exit 1
54 }
55
56 CleanUp() {
57         if [ -n "$post_exec" ]; then
58                 echo "Executing \"$post_exec\" ..."
59                 sh -c $post_exec
60                 if [ $? -ne 0 ]; then
61                         echo "Warning: post-exec command failed!"
62                 fi
63                 echo
64         fi
65         rm -f "$PIDFILE"
66 }
67
68 GotSignal() {
69         echo
70         echo "--> Got break signal, cleaning up & aborting ..."
71         echo
72         CleanUp
73         echo -n "Aborted: "; date
74         echo
75         exit 9
76 }
77
78 ExecJob() {
79         local what="$1"
80         local cmd="$2"
81
82         echo "Running job ${what}-exec command ..."
83         [ "$local" -eq 0 ] \
84                 && cmd="$ssh_cmd ${user}@${system} $cmd"
85         echo -n "Start date (${what}-exec): "; date
86         echo "$cmd"
87         if [ "$DRYRUN" -eq 0 ]; then
88                 $SHELL -c "$cmd"; local ret=$?
89         else
90                 echo " *** Trial run, not executing ${what}-exec command!"
91                 ret=0
92         fi
93         [ $ret -eq 0 ] \
94                 && echo "The ${what}-exec command completed with status 0, OK." \
95                 || echo "The ${what}-exec command completed with ERRORS, code $ret!"
96         return $ret
97 }
98
99 GetFS() {
100         local dir="$1"
101
102         while [ -n "$dir" ]; do
103                 findmnt -fn -o FSTYPE --raw "$dir" 2>/dev/null; local r=$?
104                 if [ $r -eq 0 ]; then
105                         return 0
106                 elif [ $r -eq 127 ]; then
107                         echo "UNKNOWN"
108                         return 1
109                 fi
110                 dir=$(dirname "$dir") || return 1
111         done
112 }
113
114 CreateSubvolume() {
115         local volume="$1"
116         local fs
117         local dir
118
119         dir=$(dirname "$volume")
120         fs=$(GetFS "$dir")
121         case "$fs" in
122           "btrfs")
123                 btrfs subvolume create "$volume"  >/dev/null || return 1
124                 ;;
125           *)
126                 echo "CreateSubvolume: Incompatible FS type \"$fs\" on \"$dir\"!"
127                 return 9
128         esac
129         return 0
130 }
131
132 CloneSubvolume() {
133         local source="$1"
134         local volume="$2"
135         local snapshot="$3"
136         local dir
137         local fs
138
139         dir=$(dirname "source")
140         fs=$(GetFS "$source")
141         case "$fs" in
142           "btrfs")
143                 btrfs subvolume snapshot "$source" "$snapshot"  >/dev/null || return 1
144                 ;;
145           *)
146                 echo "CloneSubvolume: Incompatible FS type \"$fs\" on \"$source\"!"
147                 return 9
148         esac
149         return 0
150 }
151
152 RenameSubvolume() {
153         local source="$1"
154         local target="$2"
155         local fs
156
157         fs=$(GetFS "$source")
158         case "$fs" in
159           "btrfs")
160                 mv "$source" "$target" || return 1
161                 ;;
162           *)
163                 echo "RenameSubvolume: Incompatible FS type \"$fs\" on \"$source\"!"
164                 return 9
165         esac
166         return 0
167 }
168
169 DeleteSubvolume() {
170         local volume="$1"
171         local fs
172
173         fs=$(GetFS "$source")
174         case "$fs" in
175           "btrfs")
176                 btrfs subvolume delete "$volume" >/dev/null || return 1
177                 ;;
178           *)
179                 echo "DeleteSubvolume: Incompatible FS type \"$fs\" on \"$volume\"!"
180                 return 9
181         esac
182         return 0
183 }
184
185 while [ $# -gt 0 ]; do
186         case "$1" in
187           "-n"|"--dry-run")
188                 DRYRUN=1; shift
189                 ;;
190           "-p"|"--progress")
191                 VERBOSE=1; shift
192                 ;;
193           "-"*)
194                 Usage
195                 ;;
196           *)
197                 break
198         esac
199 done
200
201 trap GotSignal SIGINT
202
203 echo -n "Started: "; date
204
205 for conf in "/etc/backup-script.conf" "${conf_d}/backup-script.conf"; do
206         if [ -r "$conf" ]; then
207                 echo "Reading configuration: \"$conf\" ..."
208                 source "$conf"
209         fi
210 done
211 echo
212
213 if [ $# -ge 1 ]; then
214         for s in "$@"; do
215                 if [ ! -r "${conf_d}/$s" ]; then
216                         echo "$NAME: Can' read \"${conf_d}/$s\"!"
217                         exit 1
218                 fi
219                 sys="$sys ${conf_d}/$s"
220         done
221 else
222         sys="${conf_d}/"*
223 fi
224
225 # check and create PID file
226 if [ -e "$PIDFILE" ]; then
227         echo "Lockfile \"$PIDFILE\" already exists."
228         echo "Is an other instance still running?"
229         echo
230         echo -n "Aborted: "; date
231         echo
232         exit 3
233 fi
234 touch "$PIDFILE" 2>/dev/null
235 if [ $? -ne 0 ]; then
236         echo "Warning: can't create PID file \"$PIDFILE\"!"
237         echo
238 else
239         echo "$$" >>"$PIDFILE"
240 fi
241
242 if [ -n "$pre_exec" ]; then
243         echo "Executing \"$pre_exec\" ..."
244         sh -c $pre_exec
245         if [ $? -ne 0 ]; then
246                 echo "Error: pre-exec command failed!"; echo
247                 CleanUp
248                 echo "Aborting backup."; echo
249                 exit 2
250         fi
251         sleep 2
252         echo
253 fi
254
255 for f in $sys; do
256         [ -r "$f" -a -f "$f" ] || continue
257
258         fname=$(basename "$f")
259         case "$fname" in
260                 "backup-script.conf"|*.sh)
261                         continue
262                         ;;
263         esac
264
265         # Set global defaults
266         system="$fname"
267         user="$default_user"
268         source_root="$default_source_root"
269         target="$default_target"
270         ssh_args_add="$default_ssh_args_add"
271         rsync_args_add="$default_rsync_args_add"
272         exclude_args_add="$default_exclude_args_add"
273         compress="$default_compress"
274         ping="$default_ping"
275         local="$default_local"
276         generations="$default_generations"
277         job_pre_exec="$default_job_pre_exec"
278         job_post_exec="$default_job_post_exec"
279
280         # Compatibility with backup-pull(1) script: Save global values ...
281         pre_exec_saved="$pre_exec"
282         post_exec_saved="$post_exec"
283
284         # Compatibility with backup-pull(1) script: Set defaults
285         unset host
286         unset source
287         unset pre_exec
288         unset post_exec
289
290         # Read in system configuration file
291         source "$f"
292
293         # Compatibility with backup-pull(1) script: Fix up configuration
294         [ "$system" = "$fname" -a -n "$host" ] \
295                 && system="$host"
296         [ "$source_root" = "$default_source_root" -a -n "$source" ] \
297                 && source_root="$source"
298         [ -z "$job_pre_exec" -a -n "$pre_exec" ] \
299                 && job_pre_exec="$pre_exec"
300         [ -z "$job_post_exec" -a -n "$post_exec" ] \
301                 && job_post_exec="$post_exec"
302
303         # Compatibility with backup-pull(1) script: Restore global values ...
304         pre_exec="$pre_exec_saved"
305         post_exec="$post_exec_saved"
306
307         # Validate configuration
308         [ "$system" = "localhost" -o "$system" = "127.0.0.1" ] && local=1
309
310         [ "$system" = "$fname" ] \
311                 && systxt="\"$system\"" \
312                 || systxt="\"$fname\" [\"$system\"]"
313         [ "$local" -eq 0 ] \
314                 && echo "Working on $systxt ..." \
315                 || echo "Working on $systxt (local system) ..."
316
317         count_all=$count_all+1
318
319         # Check target directory
320         if [ -z "$target" ]; then
321                 echo "No target directory specified for \"$system\"!? Skipped!"
322                 echo; continue
323         fi
324         if [ ! -d "$target" ]; then
325                 echo "Target \"$target\" is not a directory!? \"$system\" skipped!"
326                 echo; continue
327         fi
328
329         sys_target="$target/$fname"
330         sys_root="$sys_target"
331         if [ "$DRYRUN" -eq 0 ]; then
332                 mkdir -p "$sys_target" >/dev/null 2>&1
333                 if [ $? -ne 0 ]; then
334                         echo "Can't create \"$sys_target\"!? \"$system\" skipped!"
335                         echo; continue
336                 fi
337         fi
338
339         if [ "$local" -eq 0 -a "$ping" -ne 0 ]; then
340                 # Check if system is alive
341                 ping -c 1 "$system" >/dev/null 2>&1
342                 if [ $? -ne 0 ]; then
343                         echo "Host \"$system\" seems not to be alive!? Skipped."
344                         echo; continue
345                 fi
346                 echo "OK, host \"$system\" seems to be alive."
347         fi
348
349         if [ $generations -gt 0 ]; then
350                 # Make sure no old backup is stored in system directory
351                 if [ -e "$sys_target/.stamp" ]; then
352                         # There seems to be a genearation-less backup in the
353                         # target directory!
354                         echo "Target directory \"$sys_target\" seems to be unclean!? \"$system\" skipped!"
355                         echo; continue
356                 fi
357
358                 # Search directory of last generation, if any
359                 last=$(ls -1d "$sys_target"/[0-9]* 2>/dev/null | sort -r | head -n1)
360                 if [ -n "$last" ]; then
361                         if [ ! -d "$last" ]; then
362                                 echo "Last snapshot \"$last\" seems not to be a directory!? \"$system\" skipped!"
363                                 echo; continue
364                         fi
365                 fi
366                 sys_target="$sys_target/$(date +%Y%m%d-%H%M%S)"
367                 snapshot="$sys_target"
368
369                 if [ -n "$last" -a ! -e "$last/.stamp" ]; then
370                         # Old backup directory without "stamp file", continue
371                         echo "Found incomplete snapshot in \"$last\", reusing and renaming it ..."
372                         RenameSubvolume "$last" "$sys_target"
373                         if [ $? -ne 0 ]; then
374                                 echo "Failed to rename last snapshot \"$last\" to \"$sys_target\"!? \"$system\" skipped!"
375                                 echo; continue
376                         fi
377                 elif [ -n "$last" ]; then
378                         # Old backup directory found, create new snapshot
379                         echo "Found last snapshot in \"$last\"."
380                         if [ "$DRYRUN" -eq 0 ]; then
381                                 CloneSubvolume "$last" "$sys_target" "$snapshot"; r=$?
382                                 if [ $r -ne 0 ]; then
383                                         echo "Can't create snapshot \"$snapshot\" of \"$last\", code $r!? \"$system\" skipped!"
384                                         echo; continue
385                                 fi
386                                 echo "Created new snapshot in \"$snapshot\"."
387                         else
388                                 echo " *** Trial run, not creating new snapshot in \"$sys_target\"!"
389                         fi
390                 else
391                         # No old backup found, create new subvolume
392                         if [ "$DRYRUN" -eq 0 ]; then
393                                 CreateSubvolume "$sys_target"; r=$?
394                                 if [ $r -ne 0 ]; then
395                                         echo "Can't create subvolume \"$sys_target\", code $r!? \"$system\" skipped!"
396                                         echo; continue
397                                 fi
398                                 echo "Created new subvolume in \"$sys_target\"."
399                         else
400                                 echo " *** Trial run, not creating new subvolume \"$sys_target\"!"
401                         fi
402                 fi
403         fi
404
405         ssh_cmd="ssh"
406         [ -n "$ssh_args_add" ] && ssh_cmd="$ssh_cmd $ssh_args_add"
407
408         # execute job "pre-exec" command, if any
409         if [ -n "$job_pre_exec" ]; then
410                 ExecJob pre "$job_pre_exec" ; ret=$?
411                 if [ $ret -ne 0 ]; then
412                         [ $ret -ne 99 ] && count_started=$count_started+1
413                         echo "Pre-exec command failed, \"$system\" skipped!"
414                         echo; continue
415                 fi
416         fi
417
418         # prepare (remote) command ...
419         cmd="rsync --archive"
420         [ "$compress" -ne 0 ] && cmd="$cmd --compress"
421         [ "$local" -eq 0 ] && cmd="$cmd --rsh=\"$ssh_cmd\""
422         cmd="$cmd --delete --delete-excluded --sparse"
423         [ "$VERBOSE" -gt 0 ] && cmd="$cmd --progress"
424         if [ "$source_root" = "$default_source_root" ]; then
425                 cmd="$cmd --exclude=/dev --exclude=/proc --exclude=/sys"
426                 cmd="$cmd --exclude=/run --exclude=/tmp --exclude=/var/tmp"
427                 cmd="$cmd --exclude=/media --exclude=/mnt --exclude=/net"
428                 cmd="$cmd --exclude=/var/cache/apt --exclude=/var/log"
429         fi
430         [ -n "$exclude_args_add" ] && cmd="$cmd $exclude_args_add"
431         [ -n "$rsync_args_add" ] && cmd="$cmd $rsync_args_add"
432
433         [ "$local" -eq 0 ] \
434                 && cmd="$cmd ${user}@${system}:$source_root $sys_target/" \
435                 || cmd="$cmd $source_root $sys_target/"
436
437         echo "Backing up to \"$sys_target\" ..."
438         echo -n "Start date: "; date
439         echo "$cmd"
440         count_started=$count_started+1
441         ok=0
442
443         if [ "$DRYRUN" -eq 0 ]; then
444                 rm -f "$sys_target/.stamp"
445                 $SHELL -c "$cmd"; ret=$?
446                 echo "code=$ret" >"$sys_target/.stamp"
447         else
448                 echo " *** Trial run, not executing synchronization command!"
449                 ret=0
450         fi
451
452         if [ $ret -eq 20 ]; then
453                 echo "Backup of \"$system\" interrupted. Aborting ..."
454                 CleanUp
455                 exit 1
456         fi
457
458         echo -n "End date: "; date
459         if [ $ret -eq 0 -o $ret -eq 24 ]; then
460                 [ $ret -eq 24 ] && count_ok_vanished=$count_ok_vanished+1
461
462                 echo "System \"$system\" completed with status $ret, OK."
463                 [ "$DRYRUN" -gt 0 ] || count_ok=$count_ok+1
464                 ok=1
465         else
466                 echo "System \"$system\" completed with ERRORS, code $ret!"
467         fi
468
469         # execute job "post-exec" command, if any
470         if [ -n "$job_post_exec" ]; then
471                 ExecJob post "$job_post_exec"
472         fi
473
474         if [ $generations -gt 0 ]; then
475                 # Update "latest" symlink
476                 if [ "$DRYRUN" -eq 0 ]; then
477                         rm -f "$sys_root/latest"
478                         ln -s "$sys_target" "$sys_root/latest"
479                 fi
480                 # Clean up old generations
481                 declare -i gen_count=$generations+2
482                 to_delete=$(ls -1t "$sys_root" 2>/dev/null | tail -n+$gen_count | sort)
483                 if [ -n "$to_delete" -a $ok -eq 1 ]; then
484                         [ "$DRYRUN" -eq 0 ] \
485                                 && echo "Deleting old backup generations (keep $generations) ..." \
486                                 || echo " *** Trial run, not deleting old generations:"
487                         for delete in $to_delete; do
488                                 dir="$sys_root/$delete"
489                                 if [ ! -e "$dir/.stamp" ]; then
490                                         echo "Not deleting \"$dir\", not a backup directory!?"
491                                         continue
492                                 fi
493                                 last=$(stat "$dir/.stamp" 2>/dev/null | grep "^Modify: " \
494                                  | cut -d':' -f2- | cut -d. -f1)
495                                 echo "Removing backup from" $last "..."
496                                 if [ "$DRYRUN" -eq 0 ]; then
497                                         DeleteSubvolume "$dir"
498                                         [ $? -eq 0 ] || \
499                                           echo "Failed to delete \"$dir\"!"
500                                 fi
501                         done
502                         echo -n "Clean up finished: "; date
503                 elif [ -n "$to_delete" ]; then
504                         echo "There have been errors, not cleaning up old generations!"
505                 else
506                         echo "Nothing to clean up."
507                 fi
508         fi
509
510         destinations="$destinations $target"
511         echo
512 done
513
514 sync
515
516 paths=$( echo $destinations | sed -e 's/ /\n/g' | sort | uniq )
517 if [ "$DRYRUN" -eq 0 -a -n "$paths" ]; then
518         df -h $paths
519         echo
520 fi
521
522 CleanUp
523
524 echo -n "Done: "; date
525 echo
526 [ $count_all -eq 1 ] && s="" || s="s"
527 echo " - $count_all job$s defined,"
528 [ $count_started -eq 1 ] && s="" || s="s"
529 echo " - $count_started job$s started,"
530 echo " - $count_ok done without errors."
531 echo
532
533 if [ $count_started -ne $count_ok ]; then
534         echo "----->  THERE HAVE BEEN ERRORS!  <-----"
535         echo
536 fi
537
538 # -eof-